#!/bin/sh

#console X11 cursor configurator

alias nls='gettext -d cursorconfig'

#themes=`ls -d /usr/share/icons/*/cursors | sed -e 's,/usr/share/icons/,,;s,/cursors,,'`
themes=`ls -d /usr/share/icons/*/cursors /usr/local/share/icons/*/cursors ~/.local/share/icons/*/cursors ~/.icons/*/cursors | sed -e 's,/usr/share/icons/,,;s,/cursors,,'`

if [ -z "$1" ]; then
#	echo "$(nls 'Welcome to the Xcursor theme configurator.')"
	echo "Welcome to the Xcursor theme configurator."
	echo
#	echo "$(nls 'Available themes are:')"
	echo "Available themes are :"
	echo ${themes}
	echo
	if [ -r ~/.Xresources ]; then 
	
		if [ -n `grep Xcursor.theme ~/.Xresources|sed -e "s/Xcursor\.theme:\ //g"` ]; then
			default=`grep Xcursor.theme ~/.Xresources|sed -e "s/Xcursor\.theme:\ //g"`
		fi
	
	
	elif [ -r ~/.Xdefaults ]; then 
	
		if [ -n `grep Xcursor.theme ~/.Xdefaults|sed -e "s/Xcursor\.theme:\ //g"` ]; then
			default=`grep Xcursor.theme ~/.Xdefaults|sed -e "s/Xcursor\.theme:\ //g"`
		fi
	fi

#	echo "$(nls 'Currently active:') $default"
	echo "Currently active: $default"

	echo "To change theme restart this script with theme name as argument"

else

	if [ -r ~/.Xresources ]; then 

		grep -v Xcursor.theme ~/.Xresources >> ~/.Xresources.tmp1
		echo "Xcursor.theme: $1"  >> ~/.Xresources.tmp1
		mv -f ~/.Xresources.tmp1 ~/.Xresources
	
	elif [ -r ~/.Xdefaults ]; then 
	
		grep -v Xcursor.theme ~/.Xdefaults >> ~/.Xdefaults.tmp1
		echo "Xcursor.theme: $1"  >> ~/.Xdefaults.tmp1
	        mv -f ~/.Xdefaults.tmp1 ~/.Xdefaults

	fi

#	echo "$(nls 'Switched to theme:') $1."
	echo "Switched to theme: $1."
fi
