#!/bin/sh 

name=

#obsolete: intenal locker in fly-wm in use
#xlocked=`ps -A   | grep xlock   | grep -v grep | wc -l`
#if [ "$xlocked" != "0" ] ; then
#  echo При включенном блокировщике экрана xlock вращение не выполняется
#  exit 1
#fi


connected=$(xrandr -q --verbose | grep " connected")
output=$(echo "$connected" | head -n 1 | sed -e "s/\([a-zA-Z0-9]\+\) connected.*/\1/")

if [ -z "$output" ] ; then
  echo Не найден экран для поворота
  exit 1
#else
#echo Найден экран для поворота "$output"
fi

#workaround: kill twofing and restart later!
##pkill twofing

#if no twofing (killed) no need to cut utf-tilda as the 1st field
#twofinged=`ps -A | grep twofing | grep -v grep | wc -l`
#if [ "$twofinged" != "0" ] ; then
# tmp="$(xinput list --name-only | grep -i touch | cut -f 2- -d ' ')"
#else
# tmp="$(xinput list --name-only | grep -i touch)"
#fi
#if ! test -z "$tmp"; then
#  name=$tmp
#else
name=`fly-wmfunc FLYWM_GET_TOUCHSCREENS | cut -d' ' -f1  2> /dev/null | tr '\n' ';'`
IFS=';'
#fi

COMPTON_PID=`ps -C compton -o pid=`
[ ! -z $COMPTON_PID ] && kill $COMPTON_PID

#if test -z "$name"; then
#  fly-dialog --caption "Вращение экрана" --yesno "Тачскрин не найден (см. /usr/bin/fly-rotate.sh). Продолжить?"
#  if [ "$?" = 1 ]; then
#    exit 1
#  fi
##else
##   fly-dialog --caption "Вращение экрана" --msgbox "Тачскрин-устройство найдено\n${name}"
#fi

#Try to guess about current orientation and rotate

# Find the line in "xrandr -q --verbose" output that contains current screen orientation and "strip" out current orientation. 
#rotation="$(xrandr -q --verbose | grep 'connected' | egrep -o  '\) (normal|left|inverted|right) \(' | egrep -o '(normal|left|inverted|right)')"
rotation="$(echo "$connected" | egrep -o  '\) (normal|left|inverted|right) \(' | egrep -o '(normal|left|inverted|right)')"


if ! test -z "$1"; then

# Workaroiund left<->right rotation failed in Qt!
VKBD_PID=`ps -C fly-vkbd -o pid=`
[ ! -z $VKBD_PID ] && fly-vkbd --minimizetotray
case "$1" in 
    left)
    if [ "$rotation" = "right" ]; then 
	xrandr --output $output --rotate normal
	if [ "$?" = 1 ]; then
	    fly-dialog --caption "Вращение экрана" --msgbox "Не удалось выполнить вращение"
	    exit 1
	fi
	sleep 3
    fi
    ;;
    right)
    if [ "$rotation" = "left" ]; then 
	xrandr --output $output --rotate normal
	if [ "$?" = 1 ]; then
	    fly-dialog --caption "Вращение экрана" --msgbox "Не удалось выполнить вращение"
	    exit 1
	fi
	sleep 3
    fi
    ;;
esac

#Do required rotation
xrandr --output $output --rotate "$1"
if [ "$?" = 1 ]; then
    fly-dialog --caption "Вращение экрана" --msgbox "Не удалось выполнить вращение"
    exit 1
fi

case "$1" in 
    left) 
    for name_i in ${name}; do
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axes Swap" 1
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axis Inversion" 1 0
    done
    xinput set-prop --type=int --format=8 4 "Evdev Axis Inversion" 1 0
    ;;
    right) 
    for name_i in ${name}; do
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axes Swap" 1
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axis Inversion" 0 1
    done
    xinput set-prop --type=int --format=8 4 "Evdev Axis Inversion" 0 1
    ;;
    normal) 
    for name_i in ${name}; do
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axes Swap" 0
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axis Inversion" 0 0
    done
    xinput set-prop --type=int --format=8 4 "Evdev Axis Inversion" 0 0
    ;; 
    inverted) 
    for name_i in ${name}; do
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axes Swap" 0
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axis Inversion" 1 1
    done
    xinput set-prop --type=int --format=8 4 "Evdev Axis Inversion" 1 1
    ;;
esac
else

rotateTo=
case "$rotation" in 
    normal) 
    rotateTo="left"
    ;;
    left) 
    rotateTo="normal"
    ;;
esac
if ! test -z "$rotateTo"; then
    xrandr --output $output --rotate $rotateTo
    if [ "$?" = 1 ]; then
      fly-dialog --caption "Вращение экрана" --msgbox "Не удалось выполнить вращение"
      exit 1
    fi
else
    fly-dialog --caption "Вращение экрана" --msgbox "Не удалось определить текущую ориентацию экрана"
    exit 1
fi

dentry=
if [ -f $HOME/.fly/toolbar/rotate.desktop ]; then 
 dentry=$HOME/.fly/toolbar/rotate.desktop
fi

# Using current screen orientation proceed to rotate screen and input tools. 
case "$rotation" in 
    normal) 
    #rotate to the right 
    if ! test -z "$dentry"; then
      cat $dentry | sed 's/Icon[ \t]*[\=]*.*$/Icon=object-rotate-right/' > /tmp/dentry.tmp
      mv -f /tmp/dentry.tmp $dentry
    fi
    for name_i in ${name}; do
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axes Swap" 1
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axis Inversion" 1 0
    done
    xinput set-prop --type=int --format=8 4 "Evdev Axis Inversion" 1 0
    ;;
    left) 
    #rotate to normal 
    if ! test -z "$dentry"; then
      cat $dentry | sed 's/Icon[ \t]*[\=]*.*$/Icon=object-rotate-left/' > /tmp/dentry.tmp
      mv -f /tmp/dentry.tmp $dentry
    fi
    for name_i in ${name}; do
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axes Swap" 0
    xinput set-prop --type=int --format=8 "${name_i}" "Evdev Axis Inversion" 0 0
    done
    xinput set-prop --type=int --format=8 4 "Evdev Axis Inversion" 0 0
    ;;
esac
fi

#restart it after all rotation
##twofing

#alex: need delay?
#sleep 1
fly-wmfunc FLYWM_ORDER_ICON

[ ! -z $COMPTON_PID ] && compton &
